#include <iostream>
#include <string>

using namespace std;

int main()
{
    string t;
    cin>>t;
    int h;
    h=t.length();

    int ii, jj, isz, jsz, i=0, j=h-1;;
    int x=0;
    while(i!=j && i<j)
    {
        if(t[i]==t[j])
        {
            i++;
            j--;
        }
        else
        {
            isz=0;
            jsz=0;
            ii=i;
            jj=j;
            while(t[ii]!=t[j] && ii!=j && ii<j) //balrol szamol
                {
                    ii++;
                    isz++;
                }
            while(t[i]!=t[jj] && i!=jj && i<jj)
                {
                    jj--;
                    jsz++;
                }

            if(isz>jsz)
            {
                x+=jsz;
                j=jj;
            }
            else
            {
                x+=isz;
                i=ii;
            }
        }
    }
    if(x!=0)
        cout<<x;
    else
    {
        int egyseges=true;
        for(i=1;i<h;i++)
            if (t[0]!=t[i])
                egyseges=false;
        if(h%2==1 || egyseges==true)
            cout<<1;
        else
            cout<<2;
    }





    return 0;
}